//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Client.StructureDataTypeTest.StructureDataTypeTest
{
    
    
    /// <summary>
    /// Class that implements the IStructureDataTypeTest interface through SiLA2
    /// </summary>
    public partial class StructureDataTypeTestClient : IStructureDataTypeTest
    {
        
        private System.Lazy<TestStructure> _structureValue;
        
        private System.Lazy<DeepStructure> _deepStructureValue;
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.test.structuredatatypetest.v1.StructureDataTypeTest";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public StructureDataTypeTestClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
            InitLazyRequests();
        }
        
        /// <summary>
        /// Returns a structure with the following elements values:
        /// - String value = 'SiLA2_Test_String_Value'
        /// - Integer value = 5124
        /// - Real value = 3.1415926
        /// - Boolean value = true
        /// - Binary value = embedded string 'SiLA2_Binary_String_Value'
        /// - Date value = 05.08.2022 respective 08/05/2022
        /// - Time value = 12:34:56
        /// - Timestamp value = 2022-08-05 12:34:56
        /// - Any type value = string 'SiLA2_Any_Type_String_Value'.
        /// </summary>
        public virtual TestStructure StructureValue
        {
            get
            {
                return _structureValue.Value;
            }
        }
        
        /// <summary>
        /// Returns a multilevel structure with the following values:
        /// - string value = 'Outer_Test_String'
        /// - integer value = 1111
        /// - middle structure value =
        /// - string value = 'Middle_Test_String'
        /// - integer value = 2222
        /// - inner structure value =
        /// - string value = 'Inner_Test_String'
        /// - integer value = 3333.
        /// </summary>
        public virtual DeepStructure DeepStructureValue
        {
            get
            {
                return _deepStructureValue.Value;
            }
        }
        
        private TestStructure RequestStructureValue()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/StructureDataTypeTest/v1/Property/StructureValue");
            try
            {
                TestStructure response = _channel.ReadProperty<PropertyResponse<TestStructureDto>>(_serviceName, "StructureValue", "org.silastandard/test/StructureDataTypeTest/v1/Property/StructureValue", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private DeepStructure RequestDeepStructureValue()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/StructureDataTypeTest/v1/Property/DeepStructureValue");
            try
            {
                DeepStructure response = _channel.ReadProperty<PropertyResponse<DeepStructureDto>>(_serviceName, "DeepStructureValue", "org.silastandard/test/StructureDataTypeTest/v1/Property/DeepStructureValue", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Initializes lazies for non-observable properties.
        /// </summary>
        private void InitLazyRequests()
        {
            _structureValue = new System.Lazy<TestStructure>(RequestStructureValue);
            _deepStructureValue = new System.Lazy<DeepStructure>(RequestDeepStructureValue);
        }
        
        /// <summary>
        /// Receives a structure value and returns the structure that has been received (binary value is expected to be an embedded value, any typer value is expected to be a Basic type).
        /// </summary>
        /// <param name="structureValue">The Structure value to be returned.</param>
        public virtual TestStructure EchoStructureValue(TestStructure structureValue)
        {
            EchoStructureValueRequestDto request = new EchoStructureValueRequestDto(structureValue, _executionManager.CreateBinaryStore("org.silastandard/test/StructureDataTypeTest/v1/Command/EchoStructureValue/Paramet" +
                        "er/StructureValue"));
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/StructureDataTypeTest/v1/Command/EchoStructureValue");
            try
            {
                TestStructure response = _channel.ExecuteUnobservableCommand<EchoStructureValueRequestDto, EchoStructureValueResponseDto>(_serviceName, "EchoStructureValue", request, callInfo).ReceivedValues.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Receives a multilevel structure value and returns the structure that has been received.
        /// </summary>
        /// <param name="deepStructureValue">The deep Structure value to be set.</param>
        public virtual DeepStructure EchoDeepStructureValue(DeepStructure deepStructureValue)
        {
            EchoDeepStructureValueRequestDto request = new EchoDeepStructureValueRequestDto(deepStructureValue, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/StructureDataTypeTest/v1/Command/EchoDeepStructureValue");
            try
            {
                DeepStructure response = _channel.ExecuteUnobservableCommand<EchoDeepStructureValueRequestDto, EchoDeepStructureValueResponseDto>(_serviceName, "EchoDeepStructureValue", request, callInfo).ReceivedValues.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Structure Data Type Test.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class StructureDataTypeTestClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/test/StructureDataTypeTest/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IStructureDataTypeTest);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new StructureDataTypeTestClient(channel, executionManager);
        }
    }
}

